package javax.swing;

import javax.accessibility.AccessibleRole;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import javax.accessibility.AccessibleContext;
import javax.accessibility.Accessible;
import java.awt.Container;

public class CellRendererPane extends Container implements Accessible
{
    protected AccessibleContext accessibleContext;
    
    public CellRendererPane() {
        this.accessibleContext = null;
        this.setLayout(null);
        this.setVisible(false);
    }
    
    @Override
    public void invalidate() {
    }
    
    @Override
    public void paint(Graphics graphics) {
    }
    
    @Override
    public void update(Graphics graphics) {
    }
    
    @Override
    protected void addImpl(Component comp, Object constraints, int index) {
        if (comp.getParent() == this) {
            return;
        }
        super.addImpl(comp, constraints, index);
        return;
    }
    
    public void paintComponent(Graphics graphics, Component comp, Container container, int n, int n2, int n3, int n4, boolean b) {
        if (comp == null) {
            if (container != null) {
                Color color = graphics.getColor();
                graphics.setColor(container.getBackground());
                graphics.fillRect(n, n2, n3, n4);
                graphics.setColor(color);
            }
            return;
        }
        else {
            if (comp.getParent() != this) {
                this.add(comp);
            }
            comp.setBounds(n, n2, n3, n4);
            if (b) {
                comp.validate();
            }
            boolean n5 = false;
            if (comp instanceof JComponent && ((JComponent)comp).isDoubleBuffered()) {
                n5 = true;
                ((JComponent)comp).setDoubleBuffered(false);
            }
            Graphics create = graphics.create(n, n2, n3, n4);
            try {
                comp.paint(create);
            }
            finally {
                create.dispose();
            }
            if (n5 && comp instanceof JComponent) {
                ((JComponent)comp).setDoubleBuffered(true);
            }
            comp.setBounds(-n3, -n4, 0, 0);
            return;
        }
    }
    
    public void paintComponent(Graphics graphics, Component component, Container container, int n, int n2, int n3, int n4) {
        this.paintComponent(graphics, component, container, n, n2, n3, n4, false);
    }
    
    public void paintComponent(Graphics graphics, Component component, Container container, Rectangle rectangle) {
        this.paintComponent(graphics, component, container, rectangle.x, rectangle.y, rectangle.width, rectangle.height);
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) throws IOException {
        this.removeAll();
        objectOutputStream.defaultWriteObject();
    }
    
    @Override
    public AccessibleContext getAccessibleContext() {
        if (this.accessibleContext == null) {
            this.accessibleContext = new CellRendererPane.AccessibleCellRendererPane();
        }
        return this.accessibleContext;
    }
    
    protected class AccessibleCellRendererPane extends Container.AccessibleAWTContainer
    {
        @Override
        public AccessibleRole getAccessibleRole() {
            return AccessibleRole.PANEL;
        }
    }
}
